import React, { useCallback } from 'react';
import { useResizeDetector } from 'react-resize-detector';
var ResizeDetector = function ResizeDetector(_ref) {
  var onResizeCallback = _ref.onResizeCallback;
  var onResize = useCallback(function (width, height) {
    if (onResizeCallback) {
      onResizeCallback(width, height);
    }
  }, [onResizeCallback]);
  var _useResizeDetector = useResizeDetector({
      handleHeight: true,
      refreshMode: 'debounce',
      refreshRate: 1000,
      onResize: onResize
    }),
    ref = _useResizeDetector.ref;
  return /*#__PURE__*/React.createElement("div", {
    ref: ref
  });
};
export default ResizeDetector;