function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
import React, { Component } from 'react';
import { Pagination } from 'semantic-ui-react';
import PropTypes from "prop-types";
import { isStringEmpty } from "../static/ObjectsUtils";

/**
 * Pagination Component for tables
 *
 * @Author: Rocky Chen
 */
var TablePagination = /*#__PURE__*/function (_Component) {
  function TablePagination(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_this, "handlePaginationChange", function (e, _ref) {
      var activePage = _ref.activePage;
      //console.log(activePage)
      _this.setState({
        activePage: activePage
      });
      _this.props.getActivePages(activePage);
    });
    _this.state = {
      totalPages: props.totalPages,
      activePage: props.currentPage // always show page one by default
    };
    return _this;
  }
  _inheritsLoose(TablePagination, _Component);
  var _proto = TablePagination.prototype;
  _proto.render = function render() {
    var activePage = this.state.activePage;
    var _this$props = this.props,
      paginationProps = _this$props.paginationProps,
      totalPages = _this$props.totalPages;
    var boundaryRange = paginationProps.boundaryRange,
      ellipsisItem = paginationProps.ellipsisItem,
      size = paginationProps.size,
      firstItem = paginationProps.firstItem,
      lastItem = paginationProps.lastItem,
      nextItem = paginationProps.nextItem,
      pageItem = paginationProps.pageItem,
      prevItem = paginationProps.prevItem,
      siblingRange = paginationProps.siblingRange;

    //console.log(activePage)
    return /*#__PURE__*/React.createElement(Pagination, {
      className: "right floated",
      activePage: activePage,
      onPageChange: this.handlePaginationChange,
      totalPages: totalPages,
      boundaryRange: boundaryRange,
      size: size,
      ellipsisItem: ellipsisItem,
      firstItem: firstItem,
      lastItem: lastItem,
      nextItem: nextItem,
      pageItem: pageItem,
      prevItem: prevItem,
      siblingRange: siblingRange
    });
  };
  return TablePagination;
}(Component);
_defineProperty(TablePagination, "defaultProps", {
  paginationProps: {
    size: 'small' //mini,tiny,small,medium,large,big,huge,massive
  }
});
export { TablePagination as default };
TablePagination.propTypes = process.env.NODE_ENV !== "production" ? {
  totalPages: PropTypes.number.isRequired,
  getActivePages: PropTypes.func.isRequired,
  currentPage: PropTypes.number,
  paginationProps: PropTypes.object
} : {};