"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _semanticUiReact = require("semantic-ui-react");
var _ObjectsUtils = require("./static/ObjectsUtils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
var PublicStep = exports["default"] = /*#__PURE__*/function (_Component) {
  function PublicStep(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_this, "triggerStepChanges", function (currentStep) {
      var stepOptions = _this.state.stepOptions;
      for (var i = 0; i < stepOptions.length; i++) {
        //stepOptions[i].onClick = this.onStepClick
        stepOptions[i].completed = false;
        stepOptions[i].active = false;
        stepOptions[i].disabled = true;
        if (i < currentStep) {
          stepOptions[i].active = false;
          stepOptions[i].completed = true;
          stepOptions[i].disabled = false;
        } else if (currentStep === i) {
          stepOptions[i].active = true;
          stepOptions[i].completed = false;
          stepOptions[i].disabled = false;
        } else if (i < currentStep) {
          stepOptions[i].active = false;
          stepOptions[i].completed = false;
          stepOptions[i].disabled = true;
        }
      }
    });
    _this.state = {
      stepOptions: props.stepOptions,
      currentStep: props.currentStep === undefined ? 0 : parseInt(props.currentStep, 10),
      stepSize: props.stepSize === undefined ? 'small' : props.stepSize,
      divKey: (0, _ObjectsUtils.getRandomNumber)()
    };
    return _this;
  }
  _inheritsLoose(PublicStep, _Component);
  var _proto = PublicStep.prototype;
  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState, snapshot) {
    var _this$props = this.props,
      currentStep = _this$props.currentStep,
      stepOptions = _this$props.stepOptions;
    if (currentStep !== prevProps.currentStep) {
      this.setState({
        currentStep: currentStep,
        divKey: (0, _ObjectsUtils.getRandomNumber)()
      });
      this.triggerStepChanges(currentStep);
    }
    if (stepOptions !== prevProps.stepOptions) {
      this.setState({
        stepOptions: stepOptions,
        divKey: (0, _ObjectsUtils.getRandomNumber)()
      });
    }
  };
  /*  onStepClick = (event,data) => {
        if(data){
            console.log(data);
            if(data.completed){
             }
        }
    }
  */
  _proto.render = function render() {
    var _this$state = this.state,
      stepSize = _this$state.stepSize,
      stepOptions = _this$state.stepOptions,
      divKey = _this$state.divKey;
    return /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Step.Group, {
      key: divKey,
      size: stepSize,
      items: stepOptions
    });
  };
  return PublicStep;
}(_react.Component);
PublicStep.propTypes = process.env.NODE_ENV !== "production" ? {
  stepOptions: _propTypes["default"].array.isRequired,
  currentStep: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
  stepSize: _propTypes["default"].string
} : {};
module.exports = exports.default;