"use strict";

exports.__esModule = true;
exports.PaginationFooterSecondary = exports.PaginationFooter = exports.NoPaginationUserFooter = exports.CustomizedFooter = void 0;
var _react = _interopRequireWildcard(require("react"));
var _semanticUiReact = require("semantic-ui-react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _TablePagination = _interopRequireDefault(require("./TablePagination"));
var _ObjectsUtils = require("../static/ObjectsUtils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
//{key: 't', text: '1', value: '1'},
var pageOptions = [{
  key: 's',
  text: '10',
  value: 10
}, {
  key: 'm',
  text: '20',
  value: 20
}, {
  key: 'l',
  text: '50',
  value: 50
}];

/**
 * pagination footer example:
 * using data count and page size to calculate the pagination bar
 *
 * @type {{ colCount: *, pageSize: *, handlePageClick: *, dataCount: *}}
 */
var PaginationFooter = exports.PaginationFooter = /*#__PURE__*/function (_Component) {
  function PaginationFooter(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_this, "handlePageSizeChange", function (e, _ref) {
      var value = _ref.value;
      //Auto set page to page 1
      _this.props.handlePageClick(1);
      _this.setState({
        pageSize: value,
        footerKey: (0, _ObjectsUtils.getRandomNumber)()
      });
      _this.props.onPageSizeChange(value);
    });
    _this.state = {
      footerKey: (0, _ObjectsUtils.getRandomNumber)()
    };
    return _this;
  }
  _inheritsLoose(PaginationFooter, _Component);
  var _proto = PaginationFooter.prototype;
  _proto.handlePageClick = function handlePageClick(val) {
    this.props.handlePageClick(val);
  };
  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState, snapshot) {
    if (this.props.currentPage !== prevProps.currentPage) {
      this.setState({
        footerKey: (0, _ObjectsUtils.getRandomNumber)()
      });
    }
  };
  _proto.render = function render() {
    var _this2 = this;
    //currently only show the first Item of "footerMap" by default
    var _this$props = this.props,
      colCount = _this$props.colCount,
      pageSize = _this$props.pageSize,
      dataCount = _this$props.dataCount,
      currentPage = _this$props.currentPage,
      footerMap = _this$props.footerMap,
      paginationProps = _this$props.paginationProps;
    var footerKey = this.state.footerKey;
    return /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Table.Row, null, /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Table.HeaderCell, {
      colSpan: 1
    }, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Label, {
      color: "purple",
      ribbon: true
    }, "Page Size:"), /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Dropdown, {
      upward: true,
      floating: true,
      inline: true,
      options: pageOptions,
      defaultValue: pageSize,
      name: "pageSize",
      onChange: this.handlePageSizeChange
    }))), /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Table.HeaderCell, {
      key: footerKey,
      colSpan: colCount - 1 <= 0 ? 1 : colCount - 1
    }, footerMap.map(function (elm, j) {
      return elm;
    }), /*#__PURE__*/_react["default"].createElement(_TablePagination["default"], {
      currentPage: currentPage,
      totalPages: Math.ceil((dataCount === undefined ? 1 : dataCount) / pageSize),
      getActivePages: function getActivePages(val) {
        return _this2.handlePageClick(val);
      },
      paginationProps: paginationProps
    })));
  };
  return PaginationFooter;
}(_react.Component); // Secondary do not have page size selection label
PaginationFooter.propTypes = process.env.NODE_ENV !== "production" ? {
  colCount: _propTypes["default"].number.isRequired,
  pageSize: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]).isRequired,
  handlePageClick: _propTypes["default"].func.isRequired,
  dataCount: _propTypes["default"].number.isRequired,
  currentPage: _propTypes["default"].number.isRequired,
  onPageSizeChange: _propTypes["default"].func.isRequired,
  footerMap: _propTypes["default"].array,
  paginationProps: _propTypes["default"].object
} : {};
var PaginationFooterSecondary = exports.PaginationFooterSecondary = /*#__PURE__*/function (_Component2) {
  function PaginationFooterSecondary() {
    var _this3;
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this3 = _Component2.call.apply(_Component2, [this].concat(args)) || this;
    _defineProperty(_this3, "state", {
      footerKey: (0, _ObjectsUtils.getRandomNumber)()
    });
    return _this3;
  }
  _inheritsLoose(PaginationFooterSecondary, _Component2);
  var _proto2 = PaginationFooterSecondary.prototype;
  _proto2.componentDidUpdate = function componentDidUpdate(prevProps, prevState, snapshot) {
    if (this.props.currentPage !== prevProps.currentPage) {
      this.setState({
        footerKey: (0, _ObjectsUtils.getRandomNumber)()
      });
    }
  };
  _proto2.handlePageClick = function handlePageClick(val) {
    this.props.handlePageClick(val);
  };
  _proto2.render = function render() {
    var _this4 = this;
    //currently only show the first Item of "footerMap" by default
    var _this$props2 = this.props,
      colCount = _this$props2.colCount,
      pageSize = _this$props2.pageSize,
      dataCount = _this$props2.dataCount,
      currentPage = _this$props2.currentPage,
      footerMap = _this$props2.footerMap,
      paginationProps = _this$props2.paginationProps;
    var footerKey = this.state.footerKey;
    return /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Table.Row, null, /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Table.HeaderCell, {
      key: footerKey,
      colSpan: colCount
    }, footerMap.map(function (elm, j) {
      return elm;
    }), /*#__PURE__*/_react["default"].createElement(_TablePagination["default"], {
      currentPage: currentPage,
      totalPages: Math.ceil((dataCount === undefined ? 1 : dataCount) / pageSize),
      getActivePages: function getActivePages(val) {
        return _this4.handlePageClick(val);
      },
      paginationProps: paginationProps
    })));
  };
  return PaginationFooterSecondary;
}(_react.Component); //CustomizedFooter
PaginationFooterSecondary.propTypes = process.env.NODE_ENV !== "production" ? {
  colCount: _propTypes["default"].number.isRequired,
  pageSize: _propTypes["default"].number.isRequired,
  handlePageClick: _propTypes["default"].func.isRequired,
  dataCount: _propTypes["default"].number.isRequired,
  currentPage: _propTypes["default"].number.isRequired,
  footerMap: _propTypes["default"].array,
  paginationProps: _propTypes["default"].object
} : {};
var CustomizedFooter = exports.CustomizedFooter = /*#__PURE__*/function (_Component3) {
  function CustomizedFooter(props) {
    var _this5;
    _this5 = _Component3.call(this, props) || this;
    _this5.state = {};
    return _this5;
  }
  _inheritsLoose(CustomizedFooter, _Component3);
  var _proto3 = CustomizedFooter.prototype;
  _proto3.render = function render() {
    return /*#__PURE__*/_react["default"].createElement("div", null);
  };
  return CustomizedFooter;
}(_react.Component);
_defineProperty(CustomizedFooter, "defaultProps", {
  tableElementType: "CustomizedFooter"
});
CustomizedFooter.propTypes = process.env.NODE_ENV !== "production" ? {} : {};
var NoPaginationUserFooter = exports.NoPaginationUserFooter = /*#__PURE__*/function (_Component4) {
  function NoPaginationUserFooter() {
    var _this6;
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }
    _this6 = _Component4.call.apply(_Component4, [this].concat(args)) || this;
    _defineProperty(_this6, "state", {});
    return _this6;
  }
  _inheritsLoose(NoPaginationUserFooter, _Component4);
  var _proto4 = NoPaginationUserFooter.prototype;
  _proto4.render = function render() {
    var _this$props3 = this.props,
      colCount = _this$props3.colCount,
      footerMap = _this$props3.footerMap;
    return /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Table.Row, null, /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Table.HeaderCell, {
      colSpan: colCount
    }, footerMap.map(function (elm, j) {
      return elm;
    })));
  };
  return NoPaginationUserFooter;
}(_react.Component);
NoPaginationUserFooter.propTypes = process.env.NODE_ENV !== "production" ? {
  colCount: _propTypes["default"].number.isRequired,
  footerMap: _propTypes["default"].array
} : {};