"use strict";

exports.__esModule = true;
exports["default"] = void 0;
var _react = _interopRequireWildcard(require("react"));
var _semanticUiReact = require("semantic-ui-react");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _ObjectsUtils = require("../static/ObjectsUtils");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }
function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == typeof i ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != typeof t || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != typeof i) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
/**
 * Pagination Component for tables
 *
 * @Author: Rocky Chen
 */
var TablePagination = exports["default"] = /*#__PURE__*/function (_Component) {
  function TablePagination(props) {
    var _this;
    _this = _Component.call(this, props) || this;
    _defineProperty(_this, "handlePaginationChange", function (e, _ref) {
      var activePage = _ref.activePage;
      //console.log(activePage)
      _this.setState({
        activePage: activePage
      });
      _this.props.getActivePages(activePage);
    });
    _this.state = {
      totalPages: props.totalPages,
      activePage: props.currentPage // always show page one by default
    };
    return _this;
  }
  _inheritsLoose(TablePagination, _Component);
  var _proto = TablePagination.prototype;
  _proto.render = function render() {
    var activePage = this.state.activePage;
    var _this$props = this.props,
      paginationProps = _this$props.paginationProps,
      totalPages = _this$props.totalPages;
    var boundaryRange = paginationProps.boundaryRange,
      ellipsisItem = paginationProps.ellipsisItem,
      size = paginationProps.size,
      firstItem = paginationProps.firstItem,
      lastItem = paginationProps.lastItem,
      nextItem = paginationProps.nextItem,
      pageItem = paginationProps.pageItem,
      prevItem = paginationProps.prevItem,
      siblingRange = paginationProps.siblingRange;

    //console.log(activePage)
    return /*#__PURE__*/_react["default"].createElement(_semanticUiReact.Pagination, {
      className: "right floated",
      activePage: activePage,
      onPageChange: this.handlePaginationChange,
      totalPages: totalPages,
      boundaryRange: boundaryRange,
      size: size,
      ellipsisItem: ellipsisItem,
      firstItem: firstItem,
      lastItem: lastItem,
      nextItem: nextItem,
      pageItem: pageItem,
      prevItem: prevItem,
      siblingRange: siblingRange
    });
  };
  return TablePagination;
}(_react.Component);
_defineProperty(TablePagination, "defaultProps", {
  paginationProps: {
    size: 'small' //mini,tiny,small,medium,large,big,huge,massive
  }
});
TablePagination.propTypes = process.env.NODE_ENV !== "production" ? {
  totalPages: _propTypes["default"].number.isRequired,
  getActivePages: _propTypes["default"].func.isRequired,
  currentPage: _propTypes["default"].number,
  paginationProps: _propTypes["default"].object
} : {};
module.exports = exports.default;